﻿using System.ComponentModel.Composition;
using Microsoft.Practices.Prism.MefExtensions.Modularity;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.Regions;
using PrismMEF1.Infrastructure;
using PrismMEF1.MainMenuModule.Views;

namespace PrismMEF1.MainMenuModule
{
    [ModuleExport(typeof(MainMenuModuleImp))]
    public class MainMenuModuleImp : IModule
    {
        /// <summary>
        /// 레전 메니저 임포트
        /// </summary>
        [Import]
        public IRegionManager regionManager { private get; set; }

        /// <summary>
        /// 모듈이 로딩이 되자마자 지정된 레전에 들어간다.
        /// </summary>
        public void Initialize()
        {
            regionManager.RegisterViewWithRegion(RegionNames.MainMenuRegion, typeof(MainMenuView));
            regionManager.RegisterViewWithRegion(RegionNames.SubMenuRegion, typeof(SubMenuView));
        }
    }
}
