﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel.Composition;
using System.Linq;
using System.ComponentModel;

namespace MainMenuModule.Model
{
    /// <summary>
    /// 메뉴 모델 익스포트
    /// </summary>
    [Export]
    public class MenuModel : IMenuModel, INotifyPropertyChanged
    {
        #region PropertyChange
        public event PropertyChangedEventHandler PropertyChanged;

        public virtual void FirePropertyChange(string PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(PropertyName));
            }
        }
        #endregion

        ObservableCollection<string> menuCollection;
        /// <summary>
        /// 메뉴 컬렉션
        /// </summary>
        public ObservableCollection<string> MenuCollection
        {
            get { return menuCollection; }
            set
            {
                menuCollection = value;
                FirePropertyChange("MenuCollection");
            }
        }

        /// <summary>
        /// 생성자 - ImportingConstructor가 없으면 기본 생성자로 생성함
        /// </summary>
        public MenuModel()
        {
            MenuCollection = new ObservableCollection<string>();
            MenuCollection.Add("MD");
            MenuCollection.Add("SYS");
            MenuCollection.Add("SALE");
            MenuCollection.Add("WH");
        }

        #region IMenuModel Members

        /// <summary>
        /// 추가
        /// </summary>
        /// <param name="addData"></param>
        public void Adding(object addData)
        {
            if (addData != null && addData is string)
            {
                MenuCollection.Add(addData as string);
            }
        }

        /// <summary>
        /// 취소
        /// </summary>
        public void Canceling()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// 조회
        /// </summary>
        /// <param name="Condition"></param>
        public void Getting(string Condition)
        {
            if (Condition.Length == 0)
            {

            }
            else
            { 
            }
        }

        string messageData;
        /// <summary>
        /// 메시지
        /// </summary>
        public string MessageData
        {
            get
            {
                return messageData;
            }
            set
            {
                messageData = value;
                FirePropertyChange("MessageData");
            }
        }

        /// <summary>
        /// 삭제
        /// </summary>
        /// <param name="removeData"></param>
        public void Removing(object removeData)
        {
            if (removeData != null && removeData is string)
            {
                MenuCollection.Remove(removeData as string);
            }
        }

        /// <summary>
        /// 저장
        /// </summary>
        public void Saving()
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
